/*
   Pong 1.0: Programma di Pong a 2 giocatori
   Copyright (C) 2005  Destroyer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import javax.swing.*;
import java.awt.*;
import java.awt.event.MouseWheelListener;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

public class Graph extends JPanel {
 
    public Pong p;
    private JFrame f;
    private Opz panelOpz;
    private Robot rbt;
    protected int w,h,sY1,sY2;
    protected boolean pause=false,game=false;
    protected int score1,score2;
    protected MovThread thread;
    protected PcThread pc;
       
  	public Graph(JFrame f,int w,int h){
    

    this.setBackground(Color.BLACK);
       
    panelOpz=new Opz(this);
this.w=w;
this.h=h;
setPreferredSize(new Dimension(w,h));
   panelOpz.setPreferredSize(new Dimension(400,300)); 
   add(panelOpz);
	
	Input i=new Input();
    f.addMouseMotionListener(i);
  	f.addMouseWheelListener(i); 
    f.addKeyListener(i);
    this.f=f;
    try{
    rbt=new Robot();
    }catch(AWTException ex){}
   	p=new Pong(w,h);    

  		}
  
  public void resetDefVal(int w,int h){

this.w=w;
this.h=h; 
   p=new Pong(w,h);
  	repaint();  
  }

  public void paintComponent(Graphics g){
   	   	super.paintComponent(g);
   	Graphics2D g2=(Graphics2D) g;
   	
   	if (game){

   	g2.setColor(Color.white);
if (p!=null){
  if(!pause)	g2.fill(p.q);
   	g2.fill(p.r1);
   	g2.fill(p.r2);
}
   	g2.drawLine(w/2,0,w/2,h);

    if (pause){
 
    (new Num(score1,w/4,h/4)).drawOnG2D(g2);
    (new Num(score2,3*w/4,h/4)).drawOnG2D(g2);    

    }
    
}



}

public void start(){
	if (!game){
	game=true;
	thread=new MovThread();
	panelOpz.setVisible(false);
    
    if ((p1==Opz.COMPUTER)||(p2==Opz.COMPUTER)){
    pc=new PcThread();
    pc.start();}
    
    f.requestFocus();
	thread.start();
	f.setResizable(false);
	
	mouseR1=mouseR2=true;
	repaint();
	}}
public void stop(){
	if (game){
	game=false;
	thread.termina();
	panelOpz.setVisible(true);
if ((p1==Opz.COMPUTER)||(p2==Opz.COMPUTER)){
    pc.termina();}
    	
    f.setResizable(true);
	repaint();
	}}

   private int p1,p2;
   private boolean mouseR1,mouseR2;
      
   public void setPlayer(int pl,int type){
   	if (pl==1)
   	this.p1=type;
   	else
   	this.p2=type;  	
   	}
   	
class Input implements MouseMotionListener,KeyListener,MouseWheelListener
{ 
   private int yMouseMoved1,yMouseMoved2;

   private int sY;
   private Rectangle r;
   
   private boolean isP1(int type){
   	
   	if (p1==type) {
   	r=p.r1;	
   	return true;	
   	}
   	return false;
   	}
  
   private boolean isP2(int type){
   	
   	if (p2==type) {
   	r=p.r2;		
   	return true;
   	}
   	return false;
   	}   	
   
   public void relP1(){
   	sY1=sY;
   	} 
   public void relP2(){
   	sY2=sY;
   	}    	 

   private void key(KeyEvent e) {
   	
   	
   	    if((!pause)&&(game)){
   	int s=0;

   	if ((e.getKeyCode()==e.VK_UP)&&(r.getY()>p.MINy))
   	     s=-5;
   	if ((e.getKeyCode()==e.VK_DOWN)&&(r.getY()<p.MAXy))
   	     s=5;
   	     r.translate(0,s+s);     
   
   	sY=s;
   }
   	}
   private void mouse1(MouseEvent e) {
    	
   if (mouseR1) {mouseR1=false;
               yMouseMoved1=e.getY();} 
      else
   if ((!pause)&&(game)){
   	
   int transM=e.getY()-yMouseMoved1;
 
if ((((r.getY()>p.MINy)||(0<transM)))
   &&(((r.getY()<p.MAXy))||(0>transM)))
  	  
   r.translate(0,transM);

if (r.getY()<p.MINy) r.translate(0,p.MINy-(int)r.getY());
if (r.getY()>p.MAXy) r.translate(0,p.MAXy-(int)r.getY());

else transM=0;

   	mouseR1=true;
   	int stx=(int)(f.getLocation().getX()+f.getWidth()/2);
   	int sty=(int)(f.getLocation().getY()+f.getHeight()/2);
    rbt.mouseMove(stx,sty);


if (transM>0)
   sY=5;
   else if (transM<0)
   sY=-5;
   }	
   	}
   private void mouse2(MouseEvent e) {
    	
   if (mouseR2) {mouseR2=false;
               yMouseMoved2=e.getY();} 
      else
   if ((!pause)&&(game)){
   	
   int transM=e.getY()-yMouseMoved2;
 
if ((((r.getY()>p.MINy)||(0<transM)))
   &&(((r.getY()<p.MAXy))||(0>transM)))
  	  
   r.translate(0,transM);
   
if (r.getY()<p.MINy) r.translate(0,p.MINy-(int)r.getY());
if (r.getY()>p.MAXy) r.translate(0,p.MAXy-(int)r.getY());

else transM=0;

   	mouseR2=true;
   	int stx=(int)(f.getLocation().getX()+f.getWidth()/2);
   	int sty=(int)(f.getLocation().getY()+f.getHeight()/2);
    rbt.mouseMove(stx,sty);


if (transM>0)
   sY=5;
   else if (transM<0)
   sY=-5;
   }	
   	}   	
   	
   private void wheel(MouseWheelEvent e) {
   	   if((!pause)&&(game)){
   
   if ((((r.getY()>p.MINy)||(0<e.getWheelRotation())))
   &&(((r.getY()<p.MAXy))||(0>e.getWheelRotation())))
   { 
  if (r.getY()+e.getWheelRotation()*10>p.MAXy)
  r.translate(0,(int)(p.MAXy-r.getY()));     
   else if ((r.getY()+e.getWheelRotation()*10<p.MINy))
  r.translate(0,(int)(p.MINy-r.getY())); 
   else
   r.translate(0,e.getWheelRotation()*10);
   
   if (e.getWheelRotation()>0)
   sY=5;
   else
   sY=-5;
   } }
   	}
  
   private void computer() {}
  
  
   public void keyTyped(KeyEvent e){}
   public void keyPressed(KeyEvent e){

   	if (e.getKeyCode()==e.VK_P) {
   		if(pause) {

   			pause=false;}
   	   	else {
   	
  	   		pause=true;}
   	}else{
   		
   	if (isP1(Opz.TASTIERA)){
   	key(e);
   	relP1();	
   	}
   	if (isP2(Opz.TASTIERA)){
   	key(e);
   	relP2();	
   	}
    
    }
   	
   	repaint();
   	}
   public void keyReleased(KeyEvent e){}   



   public void mouseMoved(MouseEvent e)
   {
   	
   	if (isP1(Opz.MOUSE)){
   	mouse1(e);
   	relP1();	
   	}
   	if (isP2(Opz.MOUSE)){
   	mouse2(e);
   	relP2();	
   	}
   	      
   	repaint();
   	 	  	
   	}  
     

  public void mouseWheelMoved(MouseWheelEvent e){
   
    if (isP1(Opz.SCROLLER)){
   	wheel(e);
   	relP1();	
   	}
   	if (isP2(Opz.SCROLLER)){
   	wheel(e);
   	relP2();	
   	}
       
   	repaint();
  	} 

  public void mouseDragged(MouseEvent event){}


}



class PcThread extends Thread{

    private boolean run=true;

	public PcThread(){} 
	
	private int CalcPosY(){
		
		int p1,p2,x,y,x0,y0,ql;
		
		p1=(int)(p.r1.getX()+p.r1.getWidth());
		p2=(int)p.r2.getX();
		x=thread.GetX();
		y=thread.GetY();
		x0=(int)p.q.getX();
		y0=(int)p.q.getY();
		ql=(int)p.q.getWidth();
			
		if (x<0){
	
	int ret=((p1-x0)*y/x+y0);
	if ((ret<0)||(ret>h))
	if (ret<0) ret=-ret;
	else ret=h-(ret-h); 		
	   return ret;
	    			
			}else{
	
	int ret=((p2-(x0+ql))*y/x+y0); 
	if ((ret<0)||(ret>h))
	if (ret<0) ret=-ret;
	else ret=h-(ret-h); 	
	   return ret;
	   
	     	}
			
		} 
	
	public void run(){
		
		while(run){
		
		if ((p.q.getX()+p.q.getHeight()/2<w/2)&&(thread.GetX()<0)&&(p1==Opz.COMPUTER)){
			
			if ((p.r1.getY()<p.MAXy)&&(CalcPosY()>p.r1.getY()+p.r1.getHeight()/2)){
			    p.r1.translate(0,10);
			    sY1=5;
			    }
		    if ((p.r1.getY()>p.MINy)&&(CalcPosY()+p.q.getHeight()<p.r1.getY()+p.r1.getHeight()/2)){
			    p.r1.translate(0,-10);     
		        sY1=-5;
		        }
			}else 
		if ((p.q.getX()+p.q.getHeight()/2>w/2)&&(thread.GetX()>0)&&(p2==Opz.COMPUTER)){
		
			if ((p.r2.getY()<p.MAXy)&&(CalcPosY()>p.r2.getY()+p.r2.getHeight()/2)){
			    p.r2.translate(0,10);
			    sY2=5;    
			    }
		    if ((p.r2.getY()>p.MINy)&&(CalcPosY()+p.q.getHeight()<p.r2.getY()+p.r2.getHeight()/2)){
			    p.r2.translate(0,-10);
			    sY2=-5;
			    }    
			    
			}
		if (Math.random()<0.5)	
		WaitFor(30);
		else
		WaitFor(20);
		repaint();
	    while (pause);
				
		}	
		}
		
		public void termina(){
		run=false;
        }
	

	public void WaitFor(long ms){
		            try {
                super.sleep(ms);
            } catch (InterruptedException e) { }
		
		}
}


class MovThread extends Thread{
	
	private int x,y;
	private boolean run=true;
	
	public MovThread(){
		
p.q.setLocation(0,h/4);
	x=10;
	y=10;
		}
	
	public void run(){
	
		while(run){

		p.q.translate(x,y);
		
		CkMove();					
		repaint();
		WaitFor(100);
		
		while (pause);
	}
	
		}
	
	public void termina(){
		run=false;
		pause=false;		
		score1=score2=0;
		p.reset();
		
		}	
	

	public void CkMove(){
		
		urtoPareti();
		urtoP1();
		urtoP2();
		Xmove();
		sY1=sY2=0;
		
		}
		
    public void urtoP1(){
	
		if ((x<0)&&(p.r1.getX()<p.q.getX())&&(w/2>p.q.getX())){
		if ((((int)p.r1.getY())<((int)p.q.getY()+(int)p.q.height))
		   &&(((int)p.r1.getY()+(int)p.r1.height)>((int)p.q.getY()))){
		if (((int)p.r1.getX()+(int)p.r1.width)>((int)p.q.getX()+x))
		 {speed(sY1);
	      y=y+sY1;	 
		  x=-x;}
	 }else 
	    if (((sY1!=0)||(y!=0))&&((int)p.r1.getX()+(int)p.r1.width>(int)p.q.getX()+x)&&(((int)p.r1.getY()+(int)p.r1.height>(int)p.q.getY()+y)&&((int)p.r1.getY()<(int)p.q.getY()+y)||((int)p.r1.getY()<(int)p.q.getY()+(int)p.q.height+y)&&((int)p.r1.getY()+(int)p.r1.height>(int)p.q.getY()+(int)p.q.height+y))){
	    speed(sY1);
	      y=y+sY1*2;	 
		  x=-x;
	    	}
	
	    }
		
		}	
		
	public void urtoP2(){
	
		if ((x>0)&&(p.r2.getX()>p.q.getX())&&(w/2<p.q.getX())){	
		if ((((int)p.r2.getY())<((int)p.q.getY()+(int)p.q.height))
		   &&(((int)p.r2.getY()+(int)p.r2.height)>((int)p.q.getY()))){
		if (((int)p.r2.getX())<((int)p.q.getX()+(int)p.q.width+x))
		 {speed(sY2);
		  y=y+sY2;	 
		  x=-x;}		
	}else
		 if (((sY2!=0)||(y!=0))&&((int)p.r2.getX()<(int)p.q.getX()+(int)p.q.width+x)&&(((int)p.r2.getY()+(int)p.r2.height>(int)p.q.getY()+y)&&((int)p.r2.getY()<(int)p.q.getY()+y)||((int)p.r2.getY()<(int)p.q.getY()+(int)p.q.height+y)&&((int)p.r2.getY()+(int)p.r2.height>(int)p.q.getY()+(int)p.q.height+y))){
	    speed(sY2);
	      y=y+sY2*2;	 
		  x=-x;
	    	}
		
		}
		
		}	
		
	public void urtoPareti(){
		
		if ((0>((int)p.q.getY()+y))||(h<((int)p.q.getY()+y+p.q.height)))
		 {y=-y;}
		
		}
		
	public void Xmove(){

		if ((0>((int)p.q.getX()+x))||(w<((int)p.q.getX()+x)))
	{	
	if (0>((int)p.q.getX()+x)){
		p.q.setLocation(0,h/4);
	x=10;
	y=10;
    score2++;
    }
	else {
		p.q.setLocation(w,h/4);
	x=-10;
	y=10;
	score1++;
	}	
	
	pause=true;
	repaint();
	WaitFor(1000);
	pause=false;
		}
		
		}
		
	public void speed(int sY){
		if (sY==0){		
		if (x>0) x=x+3;
		if (x<0) x=x-3;
		} 
        else 
        if ((sY>0)&&(y<0)||(sY<0)&&(y>0)){
        if (x>0) x=x+2;
		if (x<0) x=x-2;
        }
        else	
        if ((x!=1)&&(x!=-1)){
        if (x>0) x=x-1;
		if (x<0) x=x+1;	
        } 
	 

		}
		
	    public int GetX(){return x;}
	    public int GetY(){return y;}
	
		public void WaitFor(long ms){
		            try {
                super.sleep(ms);
            } catch (InterruptedException e) { }
		
		}
		
	}

	
	}